//+------------------------------------------------------------------+
//|                                                       Candle.mq4 |
//|                                                           Kvant  |
//+------------------------------------------------------------------+

#property copyright "1"
#property link      "i-DarkCloud-Piersing"

#property indicator_chart_window
#property indicator_color1 White
#property indicator_color2 White
#property indicator_buffers 2

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double ExtHistoBuffer[];
double ExtHistoBuffer2[];

//----------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID);
   SetIndexBuffer(1, ExtHistoBuffer2);
   SetIndexArrow(1,241);//233
   SetIndexArrow(0,242);//234
   return(0);
}

void start()
{
  ExtHistoBuffer[0] = EMPTY_VALUE;
  ExtHistoBuffer2[0] = EMPTY_VALUE;

  int counted = IndicatorCounted();
  if (counted < 0) return;
  
  if (counted > 0) counted--;
  int limit = Bars-counted;
  
  for (int i=limit; i >= 0; i--)
  {
  
    if ((Close[i+1]>Open[i+1]) && ((Open[i]>Close[i+1]) || (High[i]>High[i+1])) && (Close[i]<Close[i+1]-((Close[i+1]-Open[i+1])/2))) 
      ExtHistoBuffer[i] = High[i]+45*Point;

    if ((Close[i+1]<Open[i+1]) && (Close[i]>Open[i]) && ((Open[i]<Close[i+1]) || (Low[i]<Low[i+1])) && (Close[i]>Close[i+1]+((Open[i+1]-Close[i+1])/2)))
      ExtHistoBuffer2[i] = Low[i]-45*Point;
  }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
         if (ExtHistoBuffer2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (ExtHistoBuffer [whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DarkCloud signal ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," DarkCloud"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," DarkCloud "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}